#include "stdafx.h"
#include "sdcedit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" {
#include "sdc_sdk.h"
}

/////////////////////////////////////////////////////////////////////////////
// CFccutilApp

BEGIN_MESSAGE_MAP(CFccutilApp, CWinApp)
	//{{AFX_MSG_MAP(CFccutilApp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFccutilApp construction

CFccutilApp::CFccutilApp()
	: CWinApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


/////////////////////////////////////////////////////////////////////////////
// The one and only CFccutilApp object

CFccutilApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFccutilApp initialization


// globals
HANDLE cardHandle = INVALID_HANDLE_VALUE;

BOOL CFccutilApp::InitInstance()
{
  SDCConfig config[5];
  SDC3rdPartyConfig config3;
  SDCGlobalConfig configG;
  SDCERR sdcErr;
  DWORD nFails=0;
  WEPKey *wKey;
  CF10G_STATUS st;
  unsigned char homeKey[13] = {0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11};
  WCHAR msg[80];
  
  memset(&config, 0, sizeof(SDCConfig)*5);
  memset(&config3, 0, sizeof(config3));
  memset(&configG, 0, sizeof(configG));


  configG.fragThreshold=FRAG_HIGH;
  configG.RTSThreshold=RTS_HIGH;
  configG.RxDiversity=RXDIV_START_MAIN;
  configG.TxDiversity=TXDIV_ON;
  configG.roamTrigger = RTRIG_70;
  configG.roamDelta	= RDELTA_20;
  configG.roamPeriod = RPERIOD_20;
  configG.preamble = PRE_AUTO;
  configG.g_shortslot =	GSHORT_AUTO;
  configG.BTcoexist	= BT_OFF;
  configG.pingPayload =	PP_32;
  configG.pingTimeout = 5000;
  configG.pingDelay	= 1000;    
  configG.authTimeout = 8;
/*
  sdcErr = SetGlobalSettings(&configG);
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Added Global Config OK"));
  else
    AfxMessageBox(_T("Added Global Config FAILED"));

  // Setting Defaults
  sprintf(config[0].configName,"config 1");
  sprintf(config[0].SSID,"Summit1");
  sprintf(config[0].clientName,"client 1");
  config[0].txPower = TXPOWER_MAX;
  config[0].authType = AUTH_OPEN;
  config[0].eapType = EAP_NONE;
  config[0].powerSave = POWERSAVE_FAST;
  config[0].wepType = WEP_ON;
  config[0].bitRate = BITRATE_AUTO;

//  config[0].bitRate = BITRATE_11;

  config[0].radioMode = RADIOMODE_BG;

  config[0].WEPKeys.size = sizeof(WEPKey);
  wKey = (WEPKey *) &config[0].WEPKeys.buffer[0];
  wKey->length = WEPLEN_128BIT | XMITBIT;
  memmove(&wKey->data[0], homeKey, 13);

  sdcErr = AddConfig(&config[0]);

  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Added Config OK"));
  else
  {
	  AfxMessageBox(_T("Added Config FAILED"));
	  nFails++;
  }

  config[0].wepType = WEP_OFF;
  sprintf(config[0].configName,"config 2");
  sprintf(config[0].SSID,"Summit2");

  sdcErr = AddConfig(&config[0]);

  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Added Config OK"));
  else
  {
	  AfxMessageBox(_T("Added Config FAILED"));
	  nFails++;
  }

  sprintf(config[0].configName,"config 3");
  sprintf(config[0].SSID,"asdnfesdflkdkb");
  sdcErr = AddConfig(&config[0]);

  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Added Config OK"));
  else
  {
	  AfxMessageBox(_T("Added Config FAILED"));
	  nFails++;
  }


  sdcErr = ActivateConfig("config 1");
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Activate Config OK"));
  else
    AfxMessageBox(_T("Activate Config FAILED"));

  if (nFails == 0)
  {
	AfxMessageBox(_T("Power Cycle, rerun test\nAdding configs should fail next run"));
	return FALSE;
  }

  AfxMessageBox(_T("Wait for connection"));
	
  sdcErr = ActivateConfig("config 2");
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Activate Config OK"));
  else
    AfxMessageBox(_T("Activate Config FAILED"));

  AfxMessageBox(_T("Wait for connection"));


  sdcErr = ActivateConfig("config 3");
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Activate Config OK"));
  else
    AfxMessageBox(_T("Activate Config FAILED"));

  AfxMessageBox(_T("Wait 30 secs, verify no connection"));


  sdcErr = ActivateConfig("config 1");
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Activate Config OK"));
  else
    AfxMessageBox(_T("Activate Config FAILED"));

  AfxMessageBox(_T("Wait for connection"));

  sdcErr = RadioDisable();
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Disable OK"));
  else
    AfxMessageBox(_T("Disable FAILED"));

  sdcErr = RadioEnable();
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Enable OK"));
  else
    AfxMessageBox(_T("Enable FAILED"));

  sdcErr = RadioDisable();
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Disable OK"));
  else
    AfxMessageBox(_T("Disable FAILED"));

  sdcErr = RadioEnable();
  if (sdcErr == SDCERR_SUCCESS)
    AfxMessageBox(_T("Enable OK"));
  else
    AfxMessageBox(_T("Enable FAILED"));

  AfxMessageBox(_T("Wait for connection"));

  sdcErr = GetCurrentStatus(&st);
  if (sdcErr == SDCERR_SUCCESS)
  {
    AfxMessageBox(_T("GetStatus OK"));

	if (st.cardState == CARDSTATE_NOT_INSERTED)
      AfxMessageBox(_T("Card not inserted"));
	else
	{
	  wsprintf(msg,_T("Card inserted\nRSSI %d"),st.rssi);
      AfxMessageBox(msg);
	}
  }
  else
    AfxMessageBox(_T("GetStatus FAILED"));

  sdcErr = GetCurrentStatus(&st);
  if (sdcErr == SDCERR_SUCCESS)
  {
    AfxMessageBox(_T("GetStatus OK"));

	if (st.cardState == CARDSTATE_NOT_INSERTED)
      AfxMessageBox(_T("Card not inserted"));
	else
	{
	  wsprintf(msg,_T("Card inserted\nRSSI %d"),st.rssi);
      AfxMessageBox(msg);
	}

  }
  else
    AfxMessageBox(_T("GetStatus FAILED"));

  sdcErr = GetCurrentStatus(&st);
  if (sdcErr == SDCERR_SUCCESS)
  {
    AfxMessageBox(_T("GetStatus OK"));

	if (st.cardState == CARDSTATE_NOT_INSERTED)
      AfxMessageBox(_T("Card not inserted"));
	else
	{
	  wsprintf(msg,_T("Card inserted\nRSSI %d"),st.rssi);
      AfxMessageBox(msg);
	}

  }
  else
    AfxMessageBox(_T("GetStatus FAILED"));
*/
  sdcErr = GetCurrentStatus(&st);
  if (sdcErr == SDCERR_SUCCESS)
  {
    AfxMessageBox(_T("GetStatus OK"));

	if (st.cardState == CARDSTATE_NOT_INSERTED)
      AfxMessageBox(_T("Card not inserted"));
	else
	{
	  wsprintf(msg,_T("Ip Address: %d.%d.%d.%d"),st.client_IP[0],st.client_IP[1],st.client_IP[2],st.client_IP[3]);
      AfxMessageBox(msg);
	}

  }
  else
    AfxMessageBox(_T("GetStatus FAILED"));

  AfxMessageBox(_T("That's all folks!"));

	return FALSE;
}

